unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Grids, Vcl.ExtCtrls,
  Vcl.Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    StringGrid1: TStringGrid;
    GroupBox1: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    Button2: TButton;
    CheckBox1: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure gauss_elimination;               // KEX̏@
    procedure gauss_elimination_basic;
    procedure GridSet(Colin, Sin: integer);    // ObhTCYύX
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  N : integer = 3;  // s̑傫l ZpTCY

  a : array of array of double;
  b : array of double;

  cHeight, cWidth : integer;      // tH[TCY

// KEX̏@ {
// Z΍􂪖̂ŏɂpivotɃ[ZG[ɂȂ܂
// z0 baseł@
procedure TForm1.gauss_elimination_basic;
var
  i, j, k : Integer;
  pivot, p : double;
begin
// Oi
  for j := 0 to N - 1 do begin
    pivot := a[j, j];                     // Ίplpivotɑ
    for k := j to  N - 1 do
      a[j, k] := a[j, k] / pivot;         // pivotōsa[j,j]1ɂ܂
    b[j] := b[j] / pivot;                 // 萔xNgpivotŊ܂
    for i := j + 1 to N - 1 do begin
      p := a[i, j];                       // j+1sȍ~j̒l
      for k := j to N - 1 do
        a[i, k] := a[i, k] - p * a[j, k]; // Wsj+1sڂjsڂ̒萔{
      b[i] := b[i] - p * b[j];            // 萔xNgj+1sڂjsڂ̒萔{
    end;
  end;
// ޑ
  for i := N - 1 downto 0 do begin        // ŏIsޏ܂
    for j := 0 to i - 1 do
      b[j] := b[j] - a[j, i] * b[i];      // ܂
  end;
// ̕\
  for i := 0 to N - 1 do
    memo1.Lines.Append('x' + inttostr(i + 1) + '  ' + floatTostr(b[i]));
end;

{$DEFINE NNM2}   // ̏V{őOia[k,k]̒l1ɂȂȂvZ܂B
                 // ύX Oia[k,k]̒l1ɂȂ܂B
// KEX̏@
// s{bgΒl傫ɌvZ܂
// z0 baseł@
procedure TForm1.gauss_elimination;
var
   i, j, k, p : integer;
   pivotmax, s : double;
begin
// Oiis{bgIj
{$IFDEF NNM2}
  for k := 0 to  N - 2 do  begin  // 悋Xebv
{$ELSE}
  for k := 0 to  N - 1 do  begin  // 悋Xebv
{$ENDIF}
    p := k;                             // ks
    pivotmax := abs(a[k][k]);
    for i := k + 1 to  N - 1 do  begin  // s{bgI ԑ傫Βl̑I
      if abs(a[i][k]) > pivotmax then begin
        p := i;                         // is
        pivotmax := abs(a[i][k]);
      end;
    end;
    // G[Fs{bg܂ɏ̓bZ[W\ďI
    if abs(pivotmax) < 1.0e-12 then begin
      memo1.Lines.Append('s{bg̒l܂B');
      exit;;
    end;
    if p <> k then begin                // 悋sƑ悐s̓ւ
      for i := k to  N - 1 do begin
        // Ws ւ
        s := a[k][i];
        a[k][i] := a[p][i];
        a[p][i] := s;
      end;
      // mxNg ւ
      s := b[k];
      b[k] := b[p];
      b[p] := s;
    end;
{$IFDEF NNM2}
{$ELSE}
    pivotmax := a[k][k];
    a[k][k] := 1;                       // a[k][k] / a[k][k] = 1  Zȗ
    for i := k + 1 to N - 1 do
      a[k][i] := a[k][i] / pivotmax;    // s{bgŏZa[k][k]1ɂ܂
    b[k] := b[k] / pivotmax;            // mxNgs{bgŏZ
{$ENDIF}
    // Oi
    for i := k + 1 to N - 1 do begin    // is
{$IFDEF NNM2}
      s := a[i][k] / a[k][k];
{$ELSE}
      s := a[i][k];
{$ENDIF}
      // 悋s a[i][k] / a[k][k] {āA悉s猸Z܂
      a[i][k] := 0.0;                   // ĂB
      for j := k + 1 to N - 1 do
        a[i][j] := a[i][j] - a[k][j] * s;
      b[i] := b[i] - b[k] * s;
    end;
  end;
// ޑ
  for i := N - 1 downto 0 do begin      // Ō̍s
    for j := i + 1 to N - 1 do begin
      b[i] := b[i] - a[i][j] * b[j];
{$IFDEF NNM2}
      a[i][j] := 0.0;                   // Ă
{$ENDIF}
    end;
{$IFDEF NNM2}
    b[i] := b[i] / a[i][i];
    a[i][i] := 1.0;                     // Ă
{$ENDIF}
  end;
// ̕\
  for i := 0 to N - 1 do
    memo1.Lines.Append('x' + inttostr(i + 1) + '  ' + floatTostr(b[i]));
end;

// ObhTCY̕ύX Ɓ@tH[̃TCYݒ
procedure TForm1.GridSet(Colin, Sin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  E, H, W : integer;                                // ȏ̓XN[
begin
  if (StringGrid1.ColCount = Colin) and (StringGrid1.RowCount = Sin) then exit;
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      W := (StringGrid1.DefaultColWidth + 1) * (11 + 1);
      StringGrid1.ScrollBars := ssBoth;           // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
  for E := 1  to Sin - 1 do begin
    StringGrid1.Cells[0, E] := 'a' + intTostr(E) + 'j';
    StringGrid1.Cells[E, 0] := 'ai' + intTostr(E);
  end;
  StringGrid1.Cells[0, 0] := 'i  \  j';
  StringGrid1.Cells[sin, 0] := 'bi';
  // tH[̃TCYZbg
  if StringGrid1.Height + StringGrid1.Top + 10 > cHeight then
    clientHeight := StringGrid1.Height + StringGrid1.Top + 10
  else
    clientHeight := cHeight;
  if StringGrid1.Width + StringGrid1.Left + 10 > cheight then
    clientWidth := StringGrid1.Width + StringGrid1.Left + 10
  else
    clientWidth := cWidth;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  i, k : integer;
begin
  cHeight := clientHeight;
  cWidth  := clientWidth;
  memo1.Clear;
  // l̃Zbg
  setlength(a, N, N);
  setlength(b, N);
  // ZplZbg
  a[0, 0] := 4;  a[0, 1] := 2; a[0, 2] := 6;
  a[1, 0] := 1;  a[1, 1] := 1; a[1, 2] := 2;
  a[2, 0] :=11;  a[2, 1] := 7; a[2, 2] := 1;
  b[0] := 32; b[1] := 10; b[2] := 77;
  GridSet(N + 2, N + 1);
  for i := 1 to N do begin
    for k := 1 to N do
      StringGrid1.Cells[i, k] := floatTostr(a[k - 1, i - 1]);
  end;
  for k := 1 to N do StringGrid1.Cells[N + 1, k] := floatTostr(b[k - 1]);
end;

// vZeXgpf[^[1
// gauss_elimination_basic({vZ)łZG[͂܂B
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  labeledEdit1.Text := '4';
  Button2Click(nil);
  with StringGrid1 do begin
    Cells[1, 1] := inttostr(1);
    Cells[2, 1] := inttostr(-1);
    Cells[3, 1] := inttostr(-2);
    Cells[4, 1] := inttostr(2);
    Cells[5, 1] := inttostr(5);
    Cells[1, 2] := inttostr(2);
    Cells[2, 2] := inttostr(-1);
    Cells[3, 2] := inttostr(-3);
    Cells[4, 2] := inttostr(3);
    Cells[5, 2] := inttostr(10);
    Cells[1, 3] := inttostr(-1);
    Cells[2, 3] := inttostr(3);
    Cells[3, 3] := inttostr(3);
    Cells[4, 3] := inttostr(-2);
    Cells[5, 3] := inttostr(2);
    Cells[1, 4] := inttostr(1);
    Cells[2, 4] := inttostr(2);
    Cells[3, 4] := inttostr(0);
    Cells[4, 4] := inttostr(-1);
    Cells[5, 4] := inttostr(-10);
  end;
  memo1.Clear;
end;

// vZeXgpf[^[2
// gauss_elimination_basic({vZ)pivot[ɂȂ
// ZG[܂B
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  labeledEdit1.Text := '3';
  Button2Click(nil);
  with StringGrid1 do begin
    Cells[1, 1] := inttostr(3);
    Cells[2, 1] := inttostr(6);
    Cells[3, 1] := inttostr(2);
    Cells[4, 1] := inttostr(32);
    Cells[1, 2] := inttostr(1);
    Cells[2, 2] := inttostr(2);
    Cells[3, 2] := inttostr(8);
    Cells[4, 2] := inttostr(40);
    Cells[1, 3] := inttostr(7);
    Cells[2, 3] := inttostr(3);
    Cells[3, 3] := inttostr(3);
    Cells[4, 3] := inttostr(35);
  end;
  memo1.Clear;
  if checkbox1.Checked = true then
    memo1.Lines.Append('{vȌꍇApivot[ɂȂ艉ZG[ł܂B');
end;

// Obhl擾 KEX̏@̉vZ
procedure TForm1.Button1Click(Sender: TObject);
var
  i, k  : integer;
  ch    : integer;
  M     : string;
begin
  // a
  for i := 1 to N do begin
    for k := 1 to N do begin
      val(StringGrid1.Cells[i, k], a[k - 1, i - 1], ch);
      if ch <> 0  then begin
        M := '̓f[^[̗ ' + intTostr(i) + #13#10
                        + ' s ' + intTostr(k) + 'ɊԈႢ܂B';
        application.MessageBox(Pchar(M),'',0);
        exit;
      end;
    end;
  end;
  // b
  for i := 1 to N do begin
    val(StringGrid1.Cells[N + 1, i], b[i - 1], ch);
    if ch <> 0  then begin
      M := '̓f[^[ bs ' + intTostr(i) + 'ɊԈႢ܂B';
      application.MessageBox(Pchar(M),'',0);
      exit;
    end;
  end;
  memo1.Clear;
  if checkbox1.Checked = true then begin
    memo1.Lines.Append('{vO');
    memo1.Lines.Append('@@ZG[΍');
    gauss_elimination_basic;         // KEX̏@{
  end
  else begin
    memo1.Lines.Append('ZG[΍􂠂');
    gauss_elimination;              // KEX̏@G[`FbN
  end;
end;

// N͂ƔzmہAObh̃Zbg
procedure TForm1.Button2Click(Sender: TObject);
var
  ch  : integer;
begin
  val(LabeledEdit1.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͒lɊԈႢ܂B', '')
  end;
  setlength(a, N, N);
  setlength(b, N);
  GridSet(N + 2, N + 1);
end;

end.

